<!DOCTYPE html>
<html lang="en">
<head>
        <meta charset="utf-8" />
        <title>Static Websites With Pelican</title>
        <link rel="stylesheet" href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/theme/css/main.css" />
        <link href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/feeds/all.atom.xml" type="application/atom+xml" rel="alternate" title="Linux And Chill Atom Feed" />
</head>

<body id="index" class="home">
        <header id="banner" class="body">
                <h1><a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/">Linux And Chill </a></h1>
                <nav><ul>
                    <li><a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/category/machine-learning.html">Machine Learning</a></li>
                    <li><a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/category/system-administration.html">System Administration</a></li>
                </ul></nav>
        </header><!-- /#banner -->
<section id="content" class="body">
  <article>
    <header>
      <h1 class="entry-title">
        <a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/drafts/how-i-made-this-website.html" rel="bookmark"
           title="Permalink to Static Websites With Pelican">Static Websites With Pelican</a></h1>
    </header>

    <div class="entry-content">
<footer class="post-info">
        <abbr class="published" title="2010-12-03T10:20:00-05:00">
                Published: Fri 03 December 2010
        </abbr>
		<br />
        <abbr class="modified" title="2010-12-05T19:30:00-05:00">
                Updated: Sun 05 December 2010
        </abbr>

        <address class="vcard author">
                By                         <a class="url fn" href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/author/timothy-pulliam.html">Timothy Pulliam</a>
        </address>
<p>In <a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/category/python.html">Python</a>.</p>
<p>tags: <a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/tag/pelican.html">pelican</a> <a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/tag/python.html">python</a> </p>
</footer><!-- /.post-info -->      <h1>How I Made This Website</h1>
<h2>Python, Pelican, and Static Websites</h2>
<p>Static webpages are websites that use static assets. HTML, CSS and Javascript. If you are writing a humble blog, you don't need any fancy database backend stuff, or server end daemon thingys like that.</p>
<p>That's where <a href="https://blog.getpelican.com/">Pelican</a> comes in. It manages HTML/CSS for you so can stick to writing content.</p>
<h2>Installation</h2>
<p>If you are familiar with Python, you install Pelican the same way you install other Python packages, using PIP.</p>
<p>First, create a virtual environment</p>
<div class="highlight"><pre><span></span>$ cd ~/code/blog
$ python3 -m venv venv
$ . venv/bin/activate
$ pip install -U pip
</pre></div>


<p>Install the requisite packages</p>
<div class="highlight"><pre><span></span>$ pip install pelican Markdown tzlocal typogrify
$ pip freeze &gt; requirements.txt
</pre></div>


<p>Quickstart a pelican project with the following command</p>
<div class="highlight"><pre><span></span>$ pelican-quickstart --title linuxandchill --author &quot;Timothy Pulliam&quot;
</pre></div>


<p>You will be prompted to answer the following questions</p>
<div class="highlight"><pre><span></span>&gt; Where do you want to create your new web site? [.]
&gt; What will be the title of this web site? [linuxandchill]
&gt; Who will be the author of this web site? [Timothy Pulliam]
&gt; What will be the default language of this web site? [en]
&gt; Do you want to specify a URL prefix? e.g., https://example.com   (Y/n)
&gt; What is your URL prefix? (see above example; no trailing slash) http://linuxandchill.xyz
&gt; Do you want to enable article pagination? (Y/n)
&gt; How many articles per page do you want? [10]
&gt; What is your time zone? [America/New_York]
&gt; Do you want to generate a tasks.py/Makefile to automate generation and publishing? (Y/n)
&gt; Do you want to upload your website using FTP? (y/N)
&gt; Do you want to upload your website using SSH? (y/N)
&gt; Do you want to upload your website using Dropbox? (y/N)
&gt; Do you want to upload your website using S3? (y/N)
&gt; Do you want to upload your website using Rackspace Cloud Files? (y/N)
&gt; Do you want to upload your website using GitHub Pages? (y/N) y
&gt; Is this your personal page (username.github.io)? (y/N) y
Done. Your new project is available at /home/tpulliam/code/blog
</pre></div>


<p>After that, you should have a directory structure similar to the one below</p>
<div class="highlight"><pre><span></span>blog/
├── content
│    ├──article.md
|    ├── images/
|         └── picture.png       
|     
├── output
├── tasks.py
├── Makefile
├── pelicanconf.py       # Main settings file
└── publishconf.py       # Settings to use when ready to publish
</pre></div>


<p>Your articles will be written in markdown files. A minimum article.md will contain the following</p>
<p>Title: My super title
Date: 2010-12-03 10:20
Modified: 2010-12-05 19:30
Category: Python
Tags: pelican, publishing
Slug: my-super-post
Authors: Alexis Metaireau, Conan Doyle
Summary: Short version for index and feeds</p>
<p>This is the content of my super blog post.</p>
<p>If you are going to include images in your articles (most likely), you can include them in a blog/content/images/ directory and reference them by adding the following line in pelicanconf.py</p>
<div class="highlight"><pre><span></span>STATIC_PATHS = [&#39;images&#39;]
</pre></div>


<p>When you write an article, you can include an image like this</p>
<div class="highlight"><pre><span></span>![Alt text]({static}/images/picture.png)
</pre></div>


<h3>Python Syntax Highlighting</h3>
<p>If you want to have your python code to be syntax highlighted like this</p>
<div class="highlight"><pre><span></span><span class="k">print</span><span class="p">(</span><span class="s2">&quot;The triple-colon syntax will *not* show line numbers.&quot;</span><span class="p">)</span>
</pre></div>


<p>To display line numbers, use a path-less shebang instead of colons:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1</pre></div></td><td class="code"><div class="highlight"><pre><span></span><span class="k">print</span><span class="p">(</span><span class="s2">&quot;The path-less shebang syntax *will* show line numbers.&quot;</span><span class="p">)</span>
</pre></div>
</td></tr></table>
    </div><!-- /.entry-content -->

  </article>
  	<style>
#pcs-comment-form input,
#pcs-comment-form textarea {
	width: 100%;
}
#pcs-comment-form-display-replyto {
	border: solid 1px black;
	padding: 2px;
}
#pcs-comment-form-display-replyto p {
	margin-top: 0.5em;
	margin-bottom: 0.5em;
}
#pcs-comments ul {
	list-style: none;
}
#pcs-comments .comment-left {
	display: table-cell;
	padding-right: 10px;
}
#pcs-comments .comment-body {
	display: table-cell;
	vertical-align: top;
	width: 100%;
}
</style>

	<section id="pcs-comments">
	<header>
		<h2>Comments</h2>
		<hr/>
	</header>
		<p>There are no comments yet.</p>
	<section>
	<form id="pcs-comment-form" action="#">
		<legend>Add a Comment</legend>
		<input type="hidden" id="pcs-comment-form-input-replyto">
		<fieldset>
			<label for="pcs-comment-form-input-name">Name</label>
			<input  id="pcs-comment-form-input-name" type="text" placeholder="Enter your name or nickname" />
		</fieldset>
		<fieldset>
			<label for="pcs-comment-form-input-website">Website</label>
			<input  id="pcs-comment-form-input-website" type="text" placeholder="Enter your website (optional)" />
		</fieldset>
		<fieldset>
			<label   for="pcs-comment-form-input-textarea">Your Comment</label>
			<textarea id="pcs-comment-form-input-textarea" rows="5" style="resize:vertical;" placeholder="Your comment"></textarea>
			<p>You can use the <a href="https://en.wikipedia.org/wiki/Markdown">Markdown</a> syntax to format your comment.</p>
			<div style="display: none; " id="pcs-comment-form-display-replyto"></div>
		</fieldset>

		<button type="submit"
				id="pcs-comment-form-button-submit"
				>Post via email</button>

	</form>
</section>

</section>

			<script type="text/javascript" src="https://code.jquery.com/jquery-2.1.4.min.js"></script>
	<script type="text/javascript" src="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/theme/js/comments.js"></script>
	<script type="text/javascript">
		$(document).ready(function() {
			CommentSystem.email_user   = "timoty.dpulliam";
			CommentSystem.email_domain = "gmail.com";
			CommentSystem.display_replyto_html = function(comment_content, article_slug, author) {
				return ''
					+ '<button style="float:right;" onclick="CommentSystem.cancelReply(); return false;" title="Cancel the reply">'
					+ 	'×'
					+ '</button>'
					+ '<p>This comment will be posted as a reply to \'<a title="'+comment_content+'" href="#comment-'+article_slug+'">'+author+'</a>\'</p>';
			};

			$('#pcs-comment-form').on("submit",
				function( event )
				{
					event.preventDefault();
					$(location).attr('href', CommentSystem.getMailtoLink("how-i-made-this-website"));
				}
			);
		});
	</script>


</section>
        <section id="extras" class="body">
                <div class="blogroll">
                        <h2>links</h2>
                        <ul>
                            <li><a href="http://getpelican.com/">Pelican</a></li>
                            <li><a href="http://python.org/">Python.org</a></li>
                            <li><a href="http://jinja.pocoo.org/">Jinja2</a></li>
                        </ul>
                </div><!-- /.blogroll -->
                <div class="social">
                        <h2>social</h2>
                        <ul>
                            <li><a href="http://linuxandchill.xyz.s3-website.us-east-1.amazonaws.com/feeds/all.atom.xml" type="application/atom+xml" rel="alternate">atom feed</a></li>

                            <li><a href="https://linkedin.com/in/timothy-pulliam">LinkedIn</a></li>
                            <li><a href="https://github.com/Timothy-Pulliam">Github</a></li>
                            <li><a href="https://www.youtube.com/channel/UC0G4YCuFJukeTicFBO6u4-A?view_as=subscriber">YouTube</a></li>
                        </ul>
                </div><!-- /.social -->
        </section><!-- /#extras -->

        <footer id="contentinfo" class="body">
                <address id="about" class="vcard body">
                Proudly powered by <a href="http://getpelican.com/">Pelican</a>, which takes great advantage of <a href="http://python.org">Python</a>.
                </address><!-- /#about -->

                <p>The theme is by <a href="http://coding.smashingmagazine.com/2009/08/04/designing-a-html-5-layout-from-scratch/">Smashing Magazine</a>, thanks!</p>
        </footer><!-- /#contentinfo -->

</body>
</html>